{
  This file was automatically generated on 2018-02-28.

  Delphi/Lazarus Bindings Version 2.1.18

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generators git on tinkerforge.com
}

unit BrickletAnalogInV3;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter, Math, SyncObjs;

const
  BRICKLET_ANALOG_IN_V3_DEVICE_IDENTIFIER = 295;
  BRICKLET_ANALOG_IN_V3_DEVICE_DISPLAY_NAME = 'Analog In Bricklet 3.0';

  BRICKLET_ANALOG_IN_V3_FUNCTION_GET_VOLTAGE = 1;
  BRICKLET_ANALOG_IN_V3_FUNCTION_SET_VOLTAGE_CALLBACK_CONFIGURATION = 2;
  BRICKLET_ANALOG_IN_V3_FUNCTION_GET_VOLTAGE_CALLBACK_CONFIGURATION = 3;
  BRICKLET_ANALOG_IN_V3_FUNCTION_SET_OVERSAMPLING = 5;
  BRICKLET_ANALOG_IN_V3_FUNCTION_GET_OVERSAMPLING = 6;
  BRICKLET_ANALOG_IN_V3_FUNCTION_SET_CALIBRATION = 7;
  BRICKLET_ANALOG_IN_V3_FUNCTION_GET_CALIBRATION = 8;
  BRICKLET_ANALOG_IN_V3_FUNCTION_GET_SPITFP_ERROR_COUNT = 234;
  BRICKLET_ANALOG_IN_V3_FUNCTION_SET_BOOTLOADER_MODE = 235;
  BRICKLET_ANALOG_IN_V3_FUNCTION_GET_BOOTLOADER_MODE = 236;
  BRICKLET_ANALOG_IN_V3_FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237;
  BRICKLET_ANALOG_IN_V3_FUNCTION_WRITE_FIRMWARE = 238;
  BRICKLET_ANALOG_IN_V3_FUNCTION_SET_STATUS_LED_CONFIG = 239;
  BRICKLET_ANALOG_IN_V3_FUNCTION_GET_STATUS_LED_CONFIG = 240;
  BRICKLET_ANALOG_IN_V3_FUNCTION_GET_CHIP_TEMPERATURE = 242;
  BRICKLET_ANALOG_IN_V3_FUNCTION_RESET = 243;
  BRICKLET_ANALOG_IN_V3_FUNCTION_WRITE_UID = 248;
  BRICKLET_ANALOG_IN_V3_FUNCTION_READ_UID = 249;
  BRICKLET_ANALOG_IN_V3_FUNCTION_GET_IDENTITY = 255;

  BRICKLET_ANALOG_IN_V3_CALLBACK_VOLTAGE = 4;

  BRICKLET_ANALOG_IN_V3_THRESHOLD_OPTION_OFF = 'x';
  BRICKLET_ANALOG_IN_V3_THRESHOLD_OPTION_OUTSIDE = 'o';
  BRICKLET_ANALOG_IN_V3_THRESHOLD_OPTION_INSIDE = 'i';
  BRICKLET_ANALOG_IN_V3_THRESHOLD_OPTION_SMALLER = '<';
  BRICKLET_ANALOG_IN_V3_THRESHOLD_OPTION_GREATER = '>';
  BRICKLET_ANALOG_IN_V3_OVERSAMPLING_32 = 0;
  BRICKLET_ANALOG_IN_V3_OVERSAMPLING_64 = 1;
  BRICKLET_ANALOG_IN_V3_OVERSAMPLING_128 = 2;
  BRICKLET_ANALOG_IN_V3_OVERSAMPLING_256 = 3;
  BRICKLET_ANALOG_IN_V3_OVERSAMPLING_512 = 4;
  BRICKLET_ANALOG_IN_V3_OVERSAMPLING_1024 = 5;
  BRICKLET_ANALOG_IN_V3_OVERSAMPLING_2048 = 6;
  BRICKLET_ANALOG_IN_V3_OVERSAMPLING_4096 = 7;
  BRICKLET_ANALOG_IN_V3_OVERSAMPLING_8192 = 8;
  BRICKLET_ANALOG_IN_V3_OVERSAMPLING_16384 = 9;
  BRICKLET_ANALOG_IN_V3_BOOTLOADER_MODE_BOOTLOADER = 0;
  BRICKLET_ANALOG_IN_V3_BOOTLOADER_MODE_FIRMWARE = 1;
  BRICKLET_ANALOG_IN_V3_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
  BRICKLET_ANALOG_IN_V3_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
  BRICKLET_ANALOG_IN_V3_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
  BRICKLET_ANALOG_IN_V3_BOOTLOADER_STATUS_OK = 0;
  BRICKLET_ANALOG_IN_V3_BOOTLOADER_STATUS_INVALID_MODE = 1;
  BRICKLET_ANALOG_IN_V3_BOOTLOADER_STATUS_NO_CHANGE = 2;
  BRICKLET_ANALOG_IN_V3_BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
  BRICKLET_ANALOG_IN_V3_BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
  BRICKLET_ANALOG_IN_V3_BOOTLOADER_STATUS_CRC_MISMATCH = 5;
  BRICKLET_ANALOG_IN_V3_STATUS_LED_CONFIG_OFF = 0;
  BRICKLET_ANALOG_IN_V3_STATUS_LED_CONFIG_ON = 1;
  BRICKLET_ANALOG_IN_V3_STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
  BRICKLET_ANALOG_IN_V3_STATUS_LED_CONFIG_SHOW_STATUS = 3;

type
  TArray0To2OfUInt8 = array [0..2] of byte;
  TArray0To63OfUInt8 = array [0..63] of byte;

  TBrickletAnalogInV3 = class;
  TBrickletAnalogInV3NotifyVoltage = procedure(sender: TBrickletAnalogInV3; const voltage: word) of object;

  /// <summary>
  ///  Measures DC voltage between 0V and 42V
  /// </summary>
  TBrickletAnalogInV3 = class(TDevice)
  private
    voltageCallback: TBrickletAnalogInV3NotifyVoltage;
  protected
    procedure CallbackWrapperVoltage(const packet: TByteArray); virtual;
  public
    /// <summary>
    ///  Creates an object with the unique device ID <c>uid</c>. This object can
    ///  then be added to the IP connection.
    /// </summary>
    constructor Create(const uid__: string; ipcon_: TIPConnection);

    /// <summary>
    ///  Returns the measured voltage. The value is in mV and
    ///  between 0V and 42V. The resolution is approximately 10mV to 1mV
    ///  depending on the oversampling configuration (<see cref="BrickletAnalogInV3.TBrickletAnalogInV3.SetOversampling"/>).
    ///  
    ///  
    ///  If you want to get the value periodically, it is recommended to use the
    ///  <see cref="BrickletAnalogInV3.TBrickletAnalogInV3.OnVoltage"/> callback. You can set the callback configuration
    ///  with <see cref="BrickletAnalogInV3.TBrickletAnalogInV3.SetVoltageCallbackConfiguration"/>.
    /// </summary>
    function GetVoltage: word; virtual;

    /// <summary>
    ///  The period in ms is the period with which the <see cref="BrickletAnalogInV3.TBrickletAnalogInV3.OnVoltage"/> callback is triggered
    ///  periodically. A value of 0 turns the callback off.
    ///  
    ///  If the `value has to change`-parameter is set to true, the callback is only
    ///  triggered after the value has changed. If the value didn't change
    ///  within the period, the callback is triggered immediately on change.
    ///  
    ///  If it is set to false, the callback is continuously triggered with the period,
    ///  independent of the value.
    ///  
    ///  It is furthermore possible to constrain the callback with thresholds.
    ///  
    ///  The `option`-parameter together with min/max sets a threshold for the <see cref="BrickletAnalogInV3.TBrickletAnalogInV3.OnVoltage"/> callback.
    ///  
    ///  The following options are possible:
    ///  
    ///  <code>
    ///   "Option", "Description"
    ///  
    ///   "'x'",    "Threshold is turned off"
    ///   "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
    ///   "'i'",    "Threshold is triggered when the value is *inside* the min and max values"
    ///   "'&lt;'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
    ///   "'&gt;'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
    ///  </code>
    ///  
    ///  
    ///  If the option is set to 'x' (threshold turned off) the callback is triggered with the fixed period.
    ///  
    ///  The default value is (0, false, 'x', 0, 0).
    /// </summary>
    procedure SetVoltageCallbackConfiguration(const period: longword; const valueHasToChange: boolean; const option: char; const min: word; const max: word); virtual;

    /// <summary>
    ///  Returns the callback configuration as set by <see cref="BrickletAnalogInV3.TBrickletAnalogInV3.SetVoltageCallbackConfiguration"/>.
    /// </summary>
    procedure GetVoltageCallbackConfiguration(out period: longword; out valueHasToChange: boolean; out option: char; out min: word; out max: word); virtual;

    /// <summary>
    ///  Sets the oversampling between 32x and 16384x. The Bricklet
    ///  takes one 12bit sample every 17.5µs. Thus an oversampling
    ///  of 32x is equivalent to an integration time of 0.56ms and
    ///  a oversampling of 16384x is equivalent to an integration
    ///  time of 286ms.
    ///  
    ///  The oversampling uses the moving average principle. A
    ///  new value is always calculated once per millisecond.
    ///  
    ///  With increased oversampling the noise decreases. With decreased
    ///  oversampling the reaction time increases (changes in voltage will be
    ///  measured faster).
    ///  
    ///  The default value is 4096x.
    /// </summary>
    procedure SetOversampling(const oversampling: byte); virtual;

    /// <summary>
    ///  Returns the oversampling value as set by <see cref="BrickletAnalogInV3.TBrickletAnalogInV3.SetOversampling"/>.
    /// </summary>
    function GetOversampling: byte; virtual;

    /// <summary>
    ///  Sets a calibration for the measured voltage value.
    ///  The formula for the calibration is as follows::
    ///  
    ///   Calibrated Value = (Value + Offset) * Multiplier / Divisor
    ///  
    ///  We recommend that you use the Brick Viewer to calibrate
    ///  the Bricklet. The calibration will be saved internally and only
    ///  has to be done once.
    /// </summary>
    procedure SetCalibration(const offset: smallint; const multiplier: word; const divisor: word); virtual;

    /// <summary>
    ///  Returns the calibration as set by <see cref="BrickletAnalogInV3.TBrickletAnalogInV3.SetCalibration"/>.
    /// </summary>
    procedure GetCalibration(out offset: smallint; out multiplier: word; out divisor: word); virtual;

    /// <summary>
    ///  Returns the error count for the communication between Brick and Bricklet.
    ///  
    ///  The errors are divided into
    ///  
    ///  * ack checksum errors,
    ///  * message checksum errors,
    ///  * frameing errors and
    ///  * overflow errors.
    ///  
    ///  The errors counts are for errors that occur on the Bricklet side. All
    ///  Bricks have a similar function that returns the errors on the Brick side.
    /// </summary>
    procedure GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword); virtual;

    /// <summary>
    ///  Sets the bootloader mode and returns the status after the requested
    ///  mode change was instigated.
    ///  
    ///  You can change from bootloader mode to firmware mode and vice versa. A change
    ///  from bootloader mode to firmware mode will only take place if the entry function,
    ///  device identifier und crc are present and correct.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function SetBootloaderMode(const mode: byte): byte; virtual;

    /// <summary>
    ///  Returns the current bootloader mode, see <see cref="BrickletAnalogInV3.TBrickletAnalogInV3.SetBootloaderMode"/>.
    /// </summary>
    function GetBootloaderMode: byte; virtual;

    /// <summary>
    ///  Sets the firmware pointer for <see cref="BrickletAnalogInV3.TBrickletAnalogInV3.WriteFirmware"/>. The pointer has
    ///  to be increased by chunks of size 64. The data is written to flash
    ///  every 4 chunks (which equals to one page of size 256).
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    procedure SetWriteFirmwarePointer(const pointer: longword); virtual;

    /// <summary>
    ///  Writes 64 Bytes of firmware at the position as written by
    ///  <see cref="BrickletAnalogInV3.TBrickletAnalogInV3.SetWriteFirmwarePointer"/> before. The firmware is written
    ///  to flash every 4 chunks.
    ///  
    ///  You can only write firmware in bootloader mode.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function WriteFirmware(const data: TArray0To63OfUInt8): byte; virtual;

    /// <summary>
    ///  Sets the status LED configuration. By default the LED shows
    ///  communication traffic between Brick and Bricklet, it flickers once
    ///  for every 10 received data packets.
    ///  
    ///  You can also turn the LED permanently on/off or show a heartbeat.
    ///  
    ///  If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    /// </summary>
    procedure SetStatusLEDConfig(const config: byte); virtual;

    /// <summary>
    ///  Returns the configuration as set by <see cref="BrickletAnalogInV3.TBrickletAnalogInV3.SetStatusLEDConfig"/>
    /// </summary>
    function GetStatusLEDConfig: byte; virtual;

    /// <summary>
    ///  Returns the temperature in °C as measured inside the microcontroller. The
    ///  value returned is not the ambient temperature!
    ///  
    ///  The temperature is only proportional to the real temperature and it has bad
    ///  accuracy. Practically it is only useful as an indicator for
    ///  temperature changes.
    /// </summary>
    function GetChipTemperature: smallint; virtual;

    /// <summary>
    ///  Calling this function will reset the Bricklet. All configurations
    ///  will be lost.
    ///  
    ///  After a reset you have to create new device objects,
    ///  calling functions on the existing ones will result in
    ///  undefined behavior!
    /// </summary>
    procedure Reset; virtual;

    /// <summary>
    ///  Writes a new UID into flash. If you want to set a new UID
    ///  you have to decode the Base58 encoded UID string into an
    ///  integer first.
    ///  
    ///  We recommend that you use Brick Viewer to change the UID.
    /// </summary>
    procedure WriteUID(const uid: longword); virtual;

    /// <summary>
    ///  Returns the current UID as an integer. Encode as
    ///  Base58 to get the usual string version.
    /// </summary>
    function ReadUID: longword; virtual;

    /// <summary>
    ///  Returns the UID, the UID where the Bricklet is connected to,
    ///  the position, the hardware and firmware version as well as the
    ///  device identifier.
    ///  
    ///  The position can be 'a', 'b', 'c' or 'd'.
    ///  
    ///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
    ///  |device_identifier_constant|
    /// </summary>
    procedure GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word); override;

    /// <summary>
    ///  This callback is triggered periodically according to the configuration set by
    ///  <see cref="BrickletAnalogInV3.TBrickletAnalogInV3.SetVoltageCallbackConfiguration"/>. 
    ///  
    ///  The `parameter` is the same as <see cref="BrickletAnalogInV3.TBrickletAnalogInV3.GetVoltage"/>.
    /// </summary>
    property OnVoltage: TBrickletAnalogInV3NotifyVoltage read voltageCallback write voltageCallback;
  end;

implementation

constructor TBrickletAnalogInV3.Create(const uid__: string; ipcon_: TIPConnection);
begin
  inherited Create(uid__, ipcon_);
  apiVersion[0] := 2;
  apiVersion[1] := 0;
  apiVersion[2] := 0;

  responseExpected[BRICKLET_ANALOG_IN_V3_FUNCTION_GET_VOLTAGE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ANALOG_IN_V3_FUNCTION_SET_VOLTAGE_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_ANALOG_IN_V3_FUNCTION_GET_VOLTAGE_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ANALOG_IN_V3_FUNCTION_SET_OVERSAMPLING] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_ANALOG_IN_V3_FUNCTION_GET_OVERSAMPLING] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ANALOG_IN_V3_FUNCTION_SET_CALIBRATION] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_ANALOG_IN_V3_FUNCTION_GET_CALIBRATION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ANALOG_IN_V3_FUNCTION_GET_SPITFP_ERROR_COUNT] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ANALOG_IN_V3_FUNCTION_SET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ANALOG_IN_V3_FUNCTION_GET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ANALOG_IN_V3_FUNCTION_SET_WRITE_FIRMWARE_POINTER] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_ANALOG_IN_V3_FUNCTION_WRITE_FIRMWARE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ANALOG_IN_V3_FUNCTION_SET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_ANALOG_IN_V3_FUNCTION_GET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ANALOG_IN_V3_FUNCTION_GET_CHIP_TEMPERATURE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ANALOG_IN_V3_FUNCTION_RESET] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_ANALOG_IN_V3_FUNCTION_WRITE_UID] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_ANALOG_IN_V3_FUNCTION_READ_UID] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ANALOG_IN_V3_FUNCTION_GET_IDENTITY] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;

  callbackWrappers[BRICKLET_ANALOG_IN_V3_CALLBACK_VOLTAGE] := {$ifdef FPC}@{$endif}CallbackWrapperVoltage;
end;

function TBrickletAnalogInV3.GetVoltage: word;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ANALOG_IN_V3_FUNCTION_GET_VOLTAGE, 8);
  response := SendRequest(request);
  result := LEConvertUInt16From(8, response);
end;

procedure TBrickletAnalogInV3.SetVoltageCallbackConfiguration(const period: longword; const valueHasToChange: boolean; const option: char; const min: word; const max: word);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ANALOG_IN_V3_FUNCTION_SET_VOLTAGE_CALLBACK_CONFIGURATION, 18);
  LEConvertUInt32To(period, 8, request);
  LEConvertBooleanTo(valueHasToChange, 12, request);
  LEConvertCharTo(option, 13, request);
  LEConvertUInt16To(min, 14, request);
  LEConvertUInt16To(max, 16, request);
  SendRequest(request);
end;

procedure TBrickletAnalogInV3.GetVoltageCallbackConfiguration(out period: longword; out valueHasToChange: boolean; out option: char; out min: word; out max: word);
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ANALOG_IN_V3_FUNCTION_GET_VOLTAGE_CALLBACK_CONFIGURATION, 8);
  response := SendRequest(request);
  period := LEConvertUInt32From(8, response);
  valueHasToChange := LEConvertBooleanFrom(12, response);
  option := LEConvertCharFrom(13, response);
  min := LEConvertUInt16From(14, response);
  max := LEConvertUInt16From(16, response);
end;

procedure TBrickletAnalogInV3.SetOversampling(const oversampling: byte);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ANALOG_IN_V3_FUNCTION_SET_OVERSAMPLING, 9);
  LEConvertUInt8To(oversampling, 8, request);
  SendRequest(request);
end;

function TBrickletAnalogInV3.GetOversampling: byte;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ANALOG_IN_V3_FUNCTION_GET_OVERSAMPLING, 8);
  response := SendRequest(request);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletAnalogInV3.SetCalibration(const offset: smallint; const multiplier: word; const divisor: word);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ANALOG_IN_V3_FUNCTION_SET_CALIBRATION, 14);
  LEConvertInt16To(offset, 8, request);
  LEConvertUInt16To(multiplier, 10, request);
  LEConvertUInt16To(divisor, 12, request);
  SendRequest(request);
end;

procedure TBrickletAnalogInV3.GetCalibration(out offset: smallint; out multiplier: word; out divisor: word);
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ANALOG_IN_V3_FUNCTION_GET_CALIBRATION, 8);
  response := SendRequest(request);
  offset := LEConvertInt16From(8, response);
  multiplier := LEConvertUInt16From(10, response);
  divisor := LEConvertUInt16From(12, response);
end;

procedure TBrickletAnalogInV3.GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword);
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ANALOG_IN_V3_FUNCTION_GET_SPITFP_ERROR_COUNT, 8);
  response := SendRequest(request);
  errorCountAckChecksum := LEConvertUInt32From(8, response);
  errorCountMessageChecksum := LEConvertUInt32From(12, response);
  errorCountFrame := LEConvertUInt32From(16, response);
  errorCountOverflow := LEConvertUInt32From(20, response);
end;

function TBrickletAnalogInV3.SetBootloaderMode(const mode: byte): byte;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ANALOG_IN_V3_FUNCTION_SET_BOOTLOADER_MODE, 9);
  LEConvertUInt8To(mode, 8, request);
  response := SendRequest(request);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletAnalogInV3.GetBootloaderMode: byte;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ANALOG_IN_V3_FUNCTION_GET_BOOTLOADER_MODE, 8);
  response := SendRequest(request);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletAnalogInV3.SetWriteFirmwarePointer(const pointer: longword);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ANALOG_IN_V3_FUNCTION_SET_WRITE_FIRMWARE_POINTER, 12);
  LEConvertUInt32To(pointer, 8, request);
  SendRequest(request);
end;

function TBrickletAnalogInV3.WriteFirmware(const data: TArray0To63OfUInt8): byte;
var request, response: TByteArray; i: longint;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ANALOG_IN_V3_FUNCTION_WRITE_FIRMWARE, 72);
  for i := 0 to Length(data) - 1 do LEConvertUInt8To(data[i], 8 + (i * 1), request);
  response := SendRequest(request);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletAnalogInV3.SetStatusLEDConfig(const config: byte);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ANALOG_IN_V3_FUNCTION_SET_STATUS_LED_CONFIG, 9);
  LEConvertUInt8To(config, 8, request);
  SendRequest(request);
end;

function TBrickletAnalogInV3.GetStatusLEDConfig: byte;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ANALOG_IN_V3_FUNCTION_GET_STATUS_LED_CONFIG, 8);
  response := SendRequest(request);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletAnalogInV3.GetChipTemperature: smallint;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ANALOG_IN_V3_FUNCTION_GET_CHIP_TEMPERATURE, 8);
  response := SendRequest(request);
  result := LEConvertInt16From(8, response);
end;

procedure TBrickletAnalogInV3.Reset;
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ANALOG_IN_V3_FUNCTION_RESET, 8);
  SendRequest(request);
end;

procedure TBrickletAnalogInV3.WriteUID(const uid: longword);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ANALOG_IN_V3_FUNCTION_WRITE_UID, 12);
  LEConvertUInt32To(uid, 8, request);
  SendRequest(request);
end;

function TBrickletAnalogInV3.ReadUID: longword;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ANALOG_IN_V3_FUNCTION_READ_UID, 8);
  response := SendRequest(request);
  result := LEConvertUInt32From(8, response);
end;

procedure TBrickletAnalogInV3.GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word);
var request, response: TByteArray; i: longint;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ANALOG_IN_V3_FUNCTION_GET_IDENTITY, 8);
  response := SendRequest(request);
  uid := LEConvertStringFrom(8, 8, response);
  connectedUid := LEConvertStringFrom(16, 8, response);
  position := LEConvertCharFrom(24, response);
  for i := 0 to 2 do hardwareVersion[i] := LEConvertUInt8From(25 + (i * 1), response);
  for i := 0 to 2 do firmwareVersion[i] := LEConvertUInt8From(28 + (i * 1), response);
  deviceIdentifier := LEConvertUInt16From(31, response);
end;

procedure TBrickletAnalogInV3.CallbackWrapperVoltage(const packet: TByteArray);
var voltage: word;
begin
  voltage := LEConvertUInt16From(8, packet);

  if (Assigned(voltageCallback)) then begin
    voltageCallback(self, voltage);
  end;
end;

end.
